<link rel="stylesheet" type="text/css" href="/admin/components/importer/styles.css" />
<?php
if(!defined('VALID_CMS_ADMIN')) { die('ACCESS DENIED'); }
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.10                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2012                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

// Создать папку /upload/tmp/
// $opt=='ifileopen' указать разделитель
    $inCore = cmsCore::getInstance();
	$inDB 	= cmsDatabase::getInstance();

    $inConf = cmsConfig::getInstance();
    $db_prefix = $inConf->db_prefix;

	if (isset($_REQUEST['opt'])) {
		$opt = $_REQUEST['opt'];
	} else {
		$opt = $inCore->request('opt', 'str', 'list');
	} // ???
	
	$id  = $inCore->request('id', 'int', 0);

	cpAddPathway('Импортер', '?view=components&do=config&id='.$id);

	echo '<h3>Импортер</h3>';
	
	$msg = '';
	
	$uploaddir = PATH.'/upload/tmp/';
	$max_file_size = 1024; // Максимальный размер файла в МегаБайтах
	
	$toolmenu = array();

	$toolmenu[0]['icon'] = 'refers.gif';
	$toolmenu[0]['title'] = 'Главная страница компонента';
	$toolmenu[0]['link'] = '?view=components&do=config&id='.$id;

	$toolmenu[1]['icon'] = 'cancel.gif';
	$toolmenu[1]['title'] = 'Выход';
	$toolmenu[1]['link'] = '?view=components';

	cpToolMenu($toolmenu);

	$cfg = $inCore->loadComponentConfig('importer');

	if($opt=='saveconfig'){

		if(!cmsCore::validateForm()) { cmsCore::error404(); }

		$cfg = array();
        $cfg['readdesc']    = $inCore->request('readdesc', 'int', 0);
		$cfg['is_url_cyrillic'] = $inCore->request('is_url_cyrillic', 'int', 0);
		$cfg['rating']      = $inCore->request('rating', 'int', 0);
		$cfg['perpage']     = $inCore->request('perpage', 'int', 0);
        $cfg['pt_show']     = $inCore->request('pt_show', 'int', 0);
		$cfg['pt_disp']     = $inCore->request('pt_disp', 'int', 0);
		$cfg['pt_hide']     = $inCore->request('pt_hide', 'int', 0);
		$cfg['autokeys']    = $inCore->request('autokeys', 'int', 0);

        $cfg['img_small_w'] = $inCore->request('img_small_w', 'int', 100);
        $cfg['img_big_w']   = $inCore->request('img_big_w', 'int', 200);
        $cfg['img_sqr']     = $inCore->request('img_sqr', 'int', 1);
        $cfg['img_users']   = $inCore->request('img_users', 'int', 1);
		$cfg['watermark']   = $inCore->request('watermark', 'int', 0);
		$cfg['watermark_only_big']   = $inCore->request('watermark_only_big', 'int', 0);

		$inCore->saveComponentConfig('importer', $cfg);

		cmsCore::addSessionMessage('Настройки успешно сохранены', 'success');

        cmsUser::clearCsrfToken();

		$inCore->redirect('?view=components&do=config&id='.$id.'&opt=config');

	}


////////////////// Главная страница компонента
if($opt=='list'){
?>
<div class="okno">
<h2>Выберите назначение импорта:</h2>
<ul>
  <li><a href="index.php?view=components&do=config&id=<?php echo $_REQUEST['id'];?>&opt=form_upload&naznachenie=concontent">Контент</a></li>
  <li><a href="index.php?view=components&do=config&id=<?php echo $_REQUEST['id'];?>&opt=form_upload&naznachenie=modquote">Цитата</a></li>
</ul>
</div>
<?php
}



// Шаг 1
/////////////////////////// Форма загрузки файла
if($opt=='form_upload'){
$naznachenie = $_REQUEST['naznachenie'];
?>
<div class="okno">
<form action="index.php?view=components&do=config&id=<?php echo $_REQUEST['id']; ?>&opt=fileuploaded" method="post" enctype="multipart/form-data">

<h3>Выберите файл CSV</h3>
<input type="file" name="filename" size="35" /><br /><br />

<input class="razdelitel right" type="text" name="razdelitel" value=";" />Разделитель поля (только один символ):<br /><br />

<input class="razdelitel right" type="text" name="ogranichitel" value=";" />Ограничитель поля (только один символ):<br /><br />

<input type="hidden" name="naznachenie" value="<?php echo $naznachenie; ?>">

<input type="submit" value="Загрузить" /><br />

</form><div class="clear"></div></div>

<?php
}


// Шаг 2
//////////////////////////// Загрузка файла
if($opt=='fileuploaded'){
$razdelitel    = $_REQUEST['razdelitel'];
$ogranichitel  = $_REQUEST['ogranichitel'];
$naznachenie   = $_REQUEST['naznachenie'];

//Проверка на соответствие - расширение и размер
$i_tmpfile      = pathinfo($_FILES["filename"]["name"], PATHINFO_EXTENSION);
$i_tmpfilesize  = $_FILES["filename"]["size"];

if($i_tmpfilesize <= $max_file_size*1024*1024 AND ($i_tmpfile == "csv" OR $i_tmpfile == "CSV")){

$i_tmpfile = "importertmp.".$i_tmpfile;//Будущее имя файла

//Загружаем с переименовкой
if(move_uploaded_file($_FILES["filename"]["tmp_name"],$uploaddir.$i_tmpfile)){
?>
<div class="okno">
<h2>Файл загружен успешно</h2>
<form action="index.php?view=components&do=config&id=<?php echo $_REQUEST['id'];?>&opt=proverkacols" method="post" name="impnazn">
<input type="hidden" name="razdelitel" value="<?php echo $razdelitel; ?>">
<input type="hidden" name="ogranichitel" value="<?php echo $ogranichitel; ?>">
<input type="hidden" name="naznachenie" value="<?php echo $naznachenie; ?>">
<input type="hidden" name="i_tmpfile" value="<?php echo $i_tmpfile; ?>">
<input type="submit" value="Дальше" /><br />
</form></div>

<?php }else{
//Что-то не получилось
$msg = 'Ошибка загрузки файла';
header('location:?view=components&do=config&id='.$_REQUEST['id'].'&opt=form_upload');
    }
}else{
if($i_tmpfilesize > $max_file_size*1024*1024){
echo 'Размер файла превышает '.$max_file_size.' Мб!<br>';
}
if($i_tmpfile != "csv" OR $i_tmpfile != "CSV"){
echo 'Допускается только CSV файл!<br>';
}
}
}


// Шаг 3
////////////////////////// Проверка количества ячеек в строках
if($opt=='proverkacols'){
$razdelitel    = $_REQUEST['razdelitel'];
$ogranichitel  = $_REQUEST['ogranichitel'];
$naznachenie   = $_REQUEST['naznachenie'];
$i_tmpfile     = $_REQUEST['i_tmpfile'];

setlocale(LC_ALL, 'ru_RU.utf-8');
$row = 0;
$handle = fopen($uploaddir.$i_tmpfile, "r");

while (($data = fgetcsv($handle, "$razdelitel", "$ogranichitel")) !== FALSE) {
    $row++;
}
$rowall = $row;
fclose($handle);

setlocale(LC_ALL, 'ru_RU.utf-8');
$row = 0;
$handle = fopen($uploaddir.$i_tmpfile, "r");
while (($data = fgetcsv($handle, "$razdelitel", "$ogranichitel")) !== FALSE) {
    $row++;
if($row == 1){
$numtitle = count($data);
}
$num = count($data);
if ($num!=$numtitle) break;
}//while end
fclose($handle);

?>
<div class="okno">
<?php if($row == $rowall){ ?>
<span class="uspeh">Количество ячеек в каждой строке одинаково. Можно идти дальше.</span><br>
<?php }else{ ?>
<span class="oshibka">Ошибка на <?php echo $row ?> строке.</span><br>
<?php } ?>

Всего <?php echo $rowall; ?> строк.<br>
Колонок - <?php echo $numtitle; ?>

<?php if($row == $rowall){ 

if($naznachenie == 'concontent'){ ?>
<form action="index.php?view=components&do=config&id=<?php echo $_REQUEST['id'];?>&opt=concontent" method="post" name="impfiltr">
<?php } 

if($naznachenie == 'modquote'){ ?>
<form action="index.php?view=components&do=config&id=<?php echo $_REQUEST['id'];?>&opt=modquote" method="post" name="impfiltr">
<?php } ?>

<input type="hidden" name="razdelitel" value="<?php echo $razdelitel; ?>">
<input type="hidden" name="ogranichitel" value="<?php echo $ogranichitel; ?>">
<input type="hidden" name="naznachenie" value="<?php echo $naznachenie; ?>">
<input type="hidden" name="i_tmpfile" value="<?php echo $i_tmpfile; ?>">
<input class="right" type="submit" value="Далее" />
<div class="clear"></div>
</form>
<?php }else{ ?>
<input class="right" type="button" value="Назад" onclick="window.location.href='index.php?view=components&do=config&id=<?php echo $_REQUEST['id']; ?>&opt=form_upload';"/>
<div class="clear"></div>
<?php } ?>
</div>
<?php
}



/////////////////////// Параметры импорта в модуль Цитата
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Шаг 4
if($opt=='modquote'){
$razdelitel    = $_REQUEST['razdelitel'];
$ogranichitel  = $_REQUEST['ogranichitel'];
$i_tmpfile     = $_REQUEST['i_tmpfile'];
?>

<form action="index.php?view=components&do=config&id=<?php echo $_REQUEST['id'];?>&opt=zapisquote" method="post" name="impfiltr">

<table class="tbl">
<?php
setlocale(LC_ALL, 'ru_RU.utf-8');
$row=0;
$x=0;
$handle = fopen($uploaddir.$i_tmpfile, "r");
while (($data = fgetcsv($handle, "$razdelitel", "$ogranichitel")) && $x++<6) {

$num = count($data);
$row++;
if($row == 1){//Если первая строка
echo "<tr>";

    for ($c=0; $c < $num; $c++) {
?>
<td class="td">

<select name="<?php echo $c; ?>">
<option value="ignor" selected>Игнорировать</option>
<option value="title">Заголовок</option>
<option value="text">Текст записи</option>
<option value="source">Источник</option>
<option value="link">Ссылка</option>
</select><br>

<strong><?php echo $data[$c] ?></strong></td>

<?php $impitem[] = $c;
    }// for end
	
echo '</tr>';
  }else{//Если НЕ первая строка
echo "<tr>";

    for ($c=0; $c < $num; $c++) { ?>
<td class="td"><?php echo $data[$c] ?></td>
<?php
    }// for end
  }// if end

echo '</tr>';
}

// Помещаем все имеющиеся столбцы в строку через |
//Каждая имеющаяся здесь цифра соответствует имени (name) селекта, по порядку столбцов в файле.
foreach ($impitem as $value) {
$impit = $impit."|".$value;
}
$impitem = $impit;
?>
</table>
<?php
fclose($handle);


// Получаем список дубликатов модуля "Цитата"
$cms_quote = $db_prefix.'_quote';
$sql = "SELECT DISTINCT mod_id FROM $cms_quote";
$result = dbQuery($sql);

// Для определения дублекатов производится выборка уникальных значений mod_id в записях "Цитаты", для этого в целевом модуле должна быть хотябы одна запись.
// Проверяем есть ли записи
	if ($inDB->num_rows($result)){
			$x=0;
			while($con = $inDB->fetch_assoc($result)){
				$x++;
				if($x == 1){
$cat = 'id = '.$con[mod_id];
				}else{
$cat = $cat.' OR id = '.$con[mod_id];
				}
			}

$cms_modules = $db_prefix.'_modules';
$sql = "SELECT * FROM $cms_modules
                WHERE $cat
				";
$result = dbQuery($sql);
?>

<div class="okno">
<p>Выберите модуль для импорта:</p>
<select name="mod_id">
<?php		while($con = $inDB->fetch_assoc($result)){ ?>
<option value="<?php echo $con['id']; ?>"><?php echo $con['title']; ?></option>
<?php		} ?>
</select><br><br>

<p>Публиковать записи:</p>
да:<input type="radio" value="1" name="published" checked="checked">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="published"><br><br>

<p>Начальная цифра порядка:</p>
<input type="text" name="ordering" value="1"><br><br>

<p><strong>Записывать первую строку:</strong></p>
да:<input type="radio" value="1" name="stroka1">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="stroka1" checked="checked"><br><br>

<input type="hidden" name="razdelitel" value="<?php echo $razdelitel; ?>">
<input type="hidden" name="ogranichitel" value="<?php echo $ogranichitel; ?>">
<input type="hidden" name="i_tmpfile" value="<?php echo $i_tmpfile; ?>">
<input type="hidden" name="impitem" value="<?php echo $impitem; ?>" />

<input class="right" type="submit" value="Далее" />
<div class="clear"></div></div>
</form>

<?php
	}else{
		echo 'Предварительно должна быть сделана хотябы одна запись, как минимум в одном модуле &laquo;Цитата&raquo;';
	}
}


// Шаг 5 (Цитата)
////////////////////////// Запись в БД
if($opt=='zapisquote'){
$razdelitel    = $_REQUEST['razdelitel'];
$ogranichitel  = $_REQUEST['ogranichitel'];
$i_tmpfile     = $_REQUEST['i_tmpfile'];
$impitem       = $_REQUEST['impitem'];

$impitem = explode("|", $impitem);//Помещаем цифры полученные на 4 шаге в масив.

////////////////
$cms_quote = $db_prefix.'_quote';//За пределами цикла, чтобы лишний раз не выполнять.
foreach ($impitem as $value) {
$punkt = $_REQUEST[$value];//$_REQUEST[0], $_REQUEST[1], $_REQUEST[2] и т.д.
	if($punkt == 'ignor')      continue;
	if($punkt == 'title')     {$title  = $value;}
	if($punkt == 'text')      {$text   = $value;}
	if($punkt == 'source')    {$source = $value;}
	if($punkt == 'link')      {$link   = $value;}
}
	  
$mod_id      = $_REQUEST['mod_id'];
$date        = date('Y-m-d H:i:s');
$dateend     = '0000-00-00 00:00:00';
$published   = $_REQUEST['published'];
$ordering    = 1;
$ordering    = $_REQUEST['ordering'];

$stroka1     = $_REQUEST['stroka1'];
////////////////

setlocale(LC_ALL, 'ru_RU.utf-8');
$x=0;
$handle = fopen($uploaddir.$i_tmpfile, "r");
while (($data = fgetcsv($handle, "$razdelitel", "$ogranichitel")) !== FALSE) {
	  $x++;
      if ($x == $stroka1) continue;

////////////////
$sql = "INSERT INTO $cms_quote
			(mod_id, title, text, source, link, date, dateend, published, ordering)
VALUES ('$mod_id', '$data[$title]', '$data[$text]', '$data[$source]', '$data[$link]', '$date', '$dateend', '$published', '$ordering')";
		dbQuery($sql) or die(mysql_error().'<pre>'.$sql.'</pre>');
$ordering++;
}
/////////////////

fclose($handle);
?>
<div class="okno"><h2 class="uspeh">Импорт выполнен успешно!</h2>
<p><strong>Записано <?php echo $x; ?> строк.</strong></p>
<input style="float:right;" type="button" value="Готово" onclick="window.location.href='index.php?view=components&do=config&id=<?php echo $_REQUEST['id']; ?>';"/><div class="clear"></div></div>
<?php
}



/////////////////////// Параметры импорта в компонент "Контент"
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Шаг 4
if($opt=='concontent'){
$razdelitel    = $_REQUEST['razdelitel'];
$ogranichitel  = $_REQUEST['ogranichitel'];
$i_tmpfile     = $_REQUEST['i_tmpfile'];
?>

<form action="index.php?view=components&do=config&id=<?php echo $_REQUEST['id'];?>&opt=zapiscontent" method="post" name="impfiltr">

<table class="tbl">
<?php
setlocale(LC_ALL, 'ru_RU.utf-8');
$row=0;
$x=0;
$handle = fopen($uploaddir.$i_tmpfile, "r");
while (($data = fgetcsv($handle, "$razdelitel", "$ogranichitel")) && $x++<6) {

$num = count($data);
$row++;
if($row == 1){//Если первая строка
echo "<tr>";

    for ($c=0; $c < $num; $c++) {
?>
<td class="td">

<select name="<?php echo $c; ?>">
<option value="ignor" selected>Игнорировать</option>
<option value="title">Заголовок</option>
<option value="description">Анонс статьи</option>
<option value="content">Текст статьи</option>
<option value="meta_desc">SEO - описание</option>
<option value="meta_keys">SEO - ключевые слова</option>
<option value="tags">Теги</option>
</select><br>

<strong><?php echo $data[$c] ?></strong></td>

<?php $impitem[] = $c;
    }// for end
	
echo '</tr>';
  }else{//Если НЕ первая строка
echo "<tr>";

    for ($c=0; $c < $num; $c++) { ?>
<td class="td"><?php echo $data[$c] ?></td>
<?php
    }// for end
  }// if end

echo '</tr>';
}

// Помещаем все имеющиеся столбцы в строку через |
//Каждая имеющаяся здесь цифра соответствует имени (name) селекта, по порядку столбцов в файле.
foreach ($impitem as $value) {
$impit = $impit."|".$value;
}
$impitem = $impit;
?>
</table>
<?php
fclose($handle);


// Получаем список имеющихся разделов
$cms_category = $db_prefix.'_category';
$sql = "SELECT * FROM $cms_category";
$result = dbQuery($sql);
?>

<div class="okno">
<p>Выберите раздел для импорта:</p>
<select name="category_id">
<?php		while($con = $inDB->fetch_assoc($result)){ ?>
<option value="<?php echo $con['id']; ?>"><?php echo $con['title']; ?></option>
<?php		} ?>
</select><br><br>

<p>Публиковать статьи:</p>
да:<input type="radio" value="1" name="published" checked="checked">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="published"><br><br>

<p>Показывать заголовки:</p>
да:<input type="radio" value="1" name="showtitle" checked="checked">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="showtitle"><br><br>

<p>Показывать даты:</p>
да:<input type="radio" value="1" name="showdate" checked="checked">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="showdate"><br><br>

<p>Показывать в "новых статьях":</p>
да:<input type="radio" value="1" name="showlatest" checked="checked">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="showlatest"><br><br>

<p>Разрешить рейтинг:</p>
да:<input type="radio" value="1" name="canrate" checked="checked">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="canrate"><br><br>

<p>Разрешить комментарии:</p>
да:<input type="radio" value="1" name="comments" checked="checked">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="comments"><br><br>

<p><strong>Записывать первую строку:</strong></p>
да:<input type="radio" value="1" name="stroka1">&nbsp;&nbsp;&nbsp;
нет:<input type="radio" value="0" name="stroka1" checked="checked"><br><br>

<input type="hidden" name="razdelitel" value="<?php echo $razdelitel; ?>">
<input type="hidden" name="ogranichitel" value="<?php echo $ogranichitel; ?>">
<input type="hidden" name="i_tmpfile" value="<?php echo $i_tmpfile; ?>">
<input type="hidden" name="impitem" value="<?php echo $impitem; ?>" />

<input class="right" type="submit" value="Далее" />
<div class="clear"></div></div>
</form>

<?php }


// Шаг 5 (Контент)
////////////////////////// Запись в БД (Контент)
if($opt=='zapiscontent'){
$razdelitel    = $_REQUEST['razdelitel'];
$ogranichitel  = $_REQUEST['ogranichitel'];
$i_tmpfile     = $_REQUEST['i_tmpfile'];
$impitem       = $_REQUEST['impitem'];

  $inPage = cmsPage::getInstance();
  cmsCore::loadModel('content');
  $model = new cms_model_content();
  $seolink = urldecode(cmsCore::request('seolink', 'str', ''));
  $seolink = preg_replace ('/[^a-zа-я-яёіїєґА-ЯЁІЇЄҐ0-9_\/\-]/ui', '', $seolink);

$impitem = explode("|", $impitem);

////////////////
foreach ($impitem as $value) {
$punkt = $_REQUEST[$value];
	if($punkt == 'ignor')        continue;
	if($punkt == 'title')       {$title       = $value;}
	if($punkt == 'description') {$description = $value;}
	if($punkt == 'content')     {$content     = $value;}
	if($punkt == 'meta_desc')   {$meta_desc   = $value;}
	if($punkt == 'meta_keys')   {$meta_keys   = $value;}
	if($punkt == 'tags')        {$tags        = $value;}
}
	  
$category_id  = $_REQUEST['category_id'];
$published    = $_REQUEST['published'];
$showtitle    = $_REQUEST['showtitle'];
$showdate     = $_REQUEST['showdate'];
$showlatest   = $_REQUEST['showlatest'];
$canrate      = $_REQUEST['canrate'];
$comments     = $_REQUEST['comments'];

$stroka1      = $_REQUEST['stroka1'];
////////////////

setlocale(LC_ALL, 'ru_RU.utf-8');
$x=0;
$handle = fopen($uploaddir.$i_tmpfile, "r");
while (($data = fgetcsv($handle, "$razdelitel", "$ogranichitel")) !== FALSE) {
	  $x++;
      if ($x == $stroka1) continue;

////////////////
        $article['category_id']  = $category_id;
        $article['user_id']      = $inUser->id;
        $article['title']        = $data[$title];
        $article['tags']         = $data[$tags];

        $article['description']  = $data[$description];
        $article['content']      = $data[$content];
        $article['description']  = $inDB->escape_string($article['description']);
        $article['content']      = $inDB->escape_string($article['content']);

        $article['published']    = $published;
        $article['pubdate']      = date('Y-m-d H:i');
        $article['enddate']      = $article['pubdate'];
        $article['is_end']       = 0;
        $article['showtitle']    = $showtitle;

		$article['meta_desc']    = $data[$meta_desc];
		$article['meta_keys']    = $data[$meta_keys];

        $article['showdate']     = $showdate;
        $article['showlatest']   = $showlatest;
        $article['showpath']     = 1;
        $article['comments']     = $comments;
        $article['canrate']      = $canrate;
        $article['pagetitle']    = '';

            $article_id = $model->addArticle($article);
}
/////////////////

fclose($handle);
?>
<div class="okno"><h2 class="uspeh">Импорт выполнен успешно!</h2>
<p><strong>Записано <?php echo $x; ?> строк.</strong></p>
<input class="right" type="button" value="Готово" onclick="window.location.href='index.php?view=components&do=config&id=<?php echo $_REQUEST['id']; ?>';"/><div class="clear"></div></div>
<?php } ?>